<?php
/**
 * Created by PhpStorm.
 * file: Gateway.php
 * project: omnipay-heepay
 * User: 李静
 * Date: 2016/12/19
 * Time: 16:47
 */

namespace Omnipay\Heepay;

use Omnipay\Common\AbstractGateway;

/**
 * Class Gateway Heepay汇付宝网关
 * @package Omnipay\Heepay
 * @author 李静
 */
class Gateway extends AbstractGateway
{
    public function getName()
    {
        return 'Heepay';
    }
    public function getDefaultParameters(){
        return array(
            'desc'=>'游戏充值',
            'key'=>'',
            'deskey'=>'',
            'partner'=>'',      //汇付宝注册的账户数字ID
            'notifyurl'=>'',
            'qq'=>'',
            'email'=>'',
            'ext_param'=>'',
        );
    }
    public function setKey($value){
        return $this->setParameter('key',$value);
    }
    public function setDesKey($value){
        return $this->setParameter('deskey',$value);
    }
    public function setPartner($value){
        return $this->setParameter('partner',$value);
    }
    public function setNotifyurl($value){
        return $this->setParameter('notifyurl',$value);
    }
    public function getKey(){
        return $this->getParameter('key');
    }
    public function getDesKey(){
        return $this->getParameter('deskey');
    }
    public function getPartner(){
        return $this->getParameter('partner');
    }
    public function getNotifyurl(){
        return $this->getParameter('notifyurl');
    }
    public function purchase(array $parameters = array()){
        return $this->createRequest('\Omnipay\Heepay\Message\HeepayPurchaseRequest', $parameters);
    }
    public function supportsCompletePurchase()
    {
        return parent::supportsCompletePurchase(); // TODO: Change the autogenerated stub
    }

    /**
     * 异步回调
     * @param array $options 回调数据
     * @return \Omnipay\Common\Message\AbstractRequest
     * @author 李静
     */
    public function completePurchase(array $options = array())
    {
        // TODO: Implement completePurchase() method.
        return $this->createRequest('\Omnipay\Heepay\Message\HeepayCompletePurchaseRequest',$options);
    }
}